<template>
  <div class="container">
    <div class="d-flex justify-content-center align-items-center flex-column">
      <form @submit.prevent="onSubmit" class="text-left">
        <b-form-group id="input-group-username" label="Username:" label-for="input-username">
          <b-form-input
            id="input-username"
            v-model="user.username"
            type="text"
            required
            placeholder="Enter username"
          ></b-form-input>
        </b-form-group>

        <b-form-group id="input-group-password" label="Password:" label-for="input-password">
          <b-form-input
            id="input-password"
            v-model="user.password"
            type="password"
            required
            placeholder="Enter password"
          ></b-form-input>
        </b-form-group>

        <b-button type="submit" class="w-100 my-2">Login</b-button>
      </form>
      <router-link to="/register">Register</router-link>
      <b-alert variant="danger" class="my-3" v-if="errors" show>{{ errors }}</b-alert>
    </div>
  </div>
</template>

<script>
export default {
  name: "Login",
  data() {
    return {
      user: {
        username: "",
        password: ""
      },
      errors: null
    };
  },
  methods: {
    onSubmit: async function() {
      const { username, password } = this.user;
      if (username.length && password.length) {
        try {
          const res = await this.$http.post("api/auth/login", {
            username,
            password
          });
          this.$store.dispatch("logged", res.body.user);
          this.$router.push("/main");
        } catch (err) {
          this.errors = err.body;
        }
      } else {
        this.errors = "Заполните все поля!";
      }
    }
  }
};
</script>
<style scoped>

</style>
